package com.bonus.sgzb.base.service.impl;

import com.bonus.sgzb.base.api.domain.SysDic;
import com.bonus.sgzb.base.mapper.SysDicMapper;
import com.bonus.sgzb.base.service.ISysDicService;
import com.bonus.sgzb.common.core.utils.DateUtils;
import com.bonus.sgzb.common.core.utils.StringUtils;
import com.bonus.sgzb.common.core.web.domain.AjaxResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 * 数据字典Service业务层处理
 *
 * @author bonus
 * @date 2023-12-11
 */
@Service
public class SysDicServiceImpl implements ISysDicService
{
    @Autowired
    private SysDicMapper sysDicMapper;

    /**
     * 查询数据字典
     *
     * @param id 数据字典主键
     * @return 数据字典
     */
    @Override
    public SysDic selectSysDicById(Long id)
    {
        return sysDicMapper.selectSysDicById(id);
    }

    /**
     * 查询数据字典列表
     *
     * @param sysDic 数据字典
     * @return 数据字典
     */
    @Override
    public List<SysDic> selectSysDicList(SysDic sysDic)
    {
        return sysDicMapper.selectSysDicList(sysDic);
    }
    /**
     * 查询数据字典列表id
     *
     * @param sysDic 数据字典
     * @return 数据字典
     */
    @Override
    public List<SysDic> selectSysDic(SysDic sysDic)
    {
        return sysDicMapper.selectSysDic(sysDic);
    }
    /**
     * 查询父类数据字典列表
     *
     * @param sysDic 数据字典
     * @return 数据字典
     */
    @Override
    public List<SysDic> selectSysDicLists(SysDic sysDic)
    {
        return sysDicMapper.selectSysDicLists(sysDic);
    }
    /**
     * 新增数据字典
     *
     * @param sysDic 数据字典
     * @return 结果
     */
    @Override
    public AjaxResult insertSysDic(SysDic sysDic)
    {
        sysDic.setCreateTime(DateUtils.getNowDate());
        SysDic info = sysDicMapper.selectByName(sysDic.getName());
        if (StringUtils.isNotNull(info)) {
            return AjaxResult.error("新增单位类型名称重复，请重新提交！！！");
        }
        return AjaxResult.success(sysDicMapper.insertSysDic(sysDic));
    }

    /**
     * 修改数据字典
     *
     * @param sysDic 数据字典
     * @return 结果
     */
    @Override
    public AjaxResult updateSysDic(SysDic sysDic)
    {
        SysDic info = sysDicMapper.selectByName(sysDic.getName());
        if (StringUtils.isNotNull(info) && info.getId().longValue() != sysDic.getId()) {
            return AjaxResult.error("单位类型名称已经存在，请重新修改提交！！！");
        }
        return AjaxResult.success(sysDicMapper.updateSysDic(sysDic));
    }
    /**
     * 修改单位状态bm_unit_type（同数据字典合并）
     *
     * @param sysDic 单位状态bm_unit_type（同数据字典合并）
     * @return 结果
     */
    @Override
    public int update(SysDic sysDic)
    {
        return  sysDicMapper.updates(sysDic);
    }
    /**
     * 批量删除数据字典
     *
     * @param ids 需要删除的数据字典主键
     * @return 结果
     */
    @Override
    public int deleteSysDicByIds(Long[] ids)
    {
        return sysDicMapper.deleteSysDicByIds(ids);
    }

    /**
     * 删除数据字典信息
     *
     * @param id 数据字典主键
     * @return 结果
     */
    @Override
    public int deleteSysDicById(Long id)
    {
        return sysDicMapper.deleteSysDicById(id);
    }

    @Override
    public List<String> getBear() {
        return sysDicMapper.getBear();
    }

}
